require 'launchy'

module Showmd
  class InputError < StandardError;end;
  class PreviewGenerator
  # Pass in a md file path, read the file, build an html file and open in the default browser
    attr_accessor :input_path, :output_path, :template_path, :markdown

    def initialize(file)
      @input_path = file
      @output_path = File.expand_path(File.join(File.dirname(__FILE__), "markdown_preview.html"))
      @template_path = File.expand_path(File.join(File.dirname(__FILE__), "template.html"))
    end

    def generate
      read_md_file
      build_html_file
      open_in_browser
    end

    def read_md_file
      begin
        @markdown = File.read(input_path)
      rescue => exception
        raise InputError, "Sorry showmd was unable to read the file, please use a valid markdown file."
      end
    end

    def build_html_file
      template_text = File.read(template_path)
      html_string = template_text.gsub(/<% markdown %>/, markdown)
      html_string.gsub!(/<% page_title %>/, File.basename(input_path))

      File.open(output_path, "w") {|file| file.puts html_string}
    end

    def open_in_browser
      Launchy.open("file://localhost/#{output_path}")
    end
  end
end